Small. Fast. Reliable.
Choose any three.

About Sitemap Documentation Download License News Developers Support

# Compilation Options For SQLite

For most purposes, SQLite can be built just fine using the default compilation options. However, if required, the compile-time options documented below can be used to omit SQLite features (resulting in a smaller compiled library size) or to change the default values of some parameters.

Every effort has been made to ensure that the various combinations of compilation options work harmoniously and produce a working library. Nevertheless, it is strongly recommended that the SQLite test-suite be executed to check for errors before using an SQLite library built with non-standard compilation options.

## Options To Set Default Parameter Values

SQLITE_DEFAULT_AUTOVACUUM=<1 or 0>
This macro determines if SQLite creates databases with the auto-vacuum flag set by default. The default value is 0 (do not create auto-vacuum databases). In any case the compile-time default may be overridden by the "PRAGMA auto_vacuum" command.

SQLITE_DEFAULT_CACHE_SIZE=<pages>
This macro sets the default size of the page-cache for each attached database, in pages. This can be overridden by the "PRAGMA cache_size" comamnd. The default value is 2000.

SQLITE_DEFAULT_PAGE_SIZE=<bytes>
This macro is used to set the default page-size used when a database is created. The value assigned must be a power of 2. The default value is 1024. The compile-time default may be overridden at runtime by the "PRAGMA page_size" command.

SQLITE_DEFAULT_TEMP_CACHE_SIZE=<pages>
This macro sets the default size of the page-cache for temporary files created by SQLite to store intermediate results, in pages. It does not affect the page-cache for the temp database, where tables created using "CREATE TEMP TABLE" are stored. The default value is 500.

SQLITE_MAX_PAGE_SIZE=<bytes>
This is used to set the maximum allowable page-size that can be specified by the "PRAGMA page_size" command. The default value is 8192.

## Options To Omit Features

The following options are used to reduce the size of the compiled library by omiting optional features. This is probably only useful in embedded systems where space is especially tight, as even with all features included the SQLite library is relatively small. Don't forget to tell your compiler to optimize for binary size! (the -Os option if using GCC).

The macros in this section do not require values. The following compilation switches all have the same effect:
-DSQLITE_OMIT_ALTERTABLE
-DSQLITE_OMIT_ALTERTABLE=1
-DSQLITE_OMIT_ALTERTABLE=0

If any of these options are defined, then the same set of SQLITE_OMIT_XXX options must also be defined when using the 'lemon' tool to generate a parse.c file. Because of this, these options may only used when the library is built from source, not from the collection of pre-packaged C files provided for non-UNIX like platforms on the website.

SQLITE_OMIT_ALTERTABLE
When this option is defined, the ALTER TABLE command is not included in the library. Executing an ALTER TABLE statement causes a parse error.

SQLITE_OMIT_AUTHORIZATION
Defining this option omits the authorization callback feature from the library. The sqlite3_set_authorizer() API function is not present in the library.

SQLITE_OMIT_AUTOVACUUM
If this option is defined, the library cannot create or write to databases that support auto-vacuum. Executing a "PRAGMA auto_vacuum" statement is not an error, but does not return a value or modify the auto-vacuum flag in the database file. If a database that supports auto-vacuum is opened by a library compiled with this option, it is automatically opened in read-only mode.

SQLITE_OMIT_AUTOINCREMENT
This option is used to omit the AUTOINCREMENT functionality. When this is macro is defined, columns declared as "INTEGER PRIMARY KEY AUTOINCREMENT" behave in the same way as columns declared as "INTEGER PRIMARY KEY" when a NULL is inserted. The sqlite_sequence system table is neither created, nor respected if it already exists.

SQLITE_OMIT_BLOB_LITERAL
When this option is defined, it is not possible to specify a blob in an SQL statement using the X'ABCD' syntax.

SQLITE_OMIT_COMPLETE
This option causes the sqlite3_complete API to be omitted.

SQLITE_OMIT_COMPOUND_SELECT
This option is used to omit the compound SELECT functionality. SELECT statements that use the UNION, UNION ALL, INTERSECT or EXCEPT compound SELECT operators will cause a parse error.

SQLITE_OMIT_CONFLICT_CLAUSE
In the future, this option will be used to omit the ON CONFLICT clause from the library.

SQLITE_OMIT_DATETIME_FUNCS
If this option is defined, SQLite's built-in date and time manipulation functions are omitted. Specifically, the SQL functions julianday(), date(), time(), datetime() and strftime() are not available. The default column values CURRENT_TIME, CURRENT_DATE and CURRENT_DATETIME are still available.

SQLITE_OMIT_EXPLAIN
Defining this option causes the EXPLAIN command to be omitted from the library. Attempting to execute an EXPLAIN statement will cause a parse error.

SQLITE_OMIT_FLOATING_POINT
This option is used to omit floating-point number support from the SQLite library. When specified, specifying a floating point number as a literal (i.e. "1.01") results in a parse error.

In the future, this option may also disable other floating point functionality, for example the sqlite3_result_double(), sqlite3_bind_double(), sqlite3_value_double() and sqlite3_column_double() API functions.

SQLITE_OMIT_FOREIGN_KEY
If this option is defined, FOREIGN KEY clauses in column declarations are ignored.

SQLITE_OMIT_INTEGRITY_CHECK
This option may be used to omit the "PRAGMA integrity_check" command from the compiled library.

SQLITE_OMIT_MEMORYDB
When this is defined, the library does not respect the special database name ":memory:" (normally used to create an in-memory database). If ":memory:" is passed to sqlite3_open(), a file with this name will be opened or created.

SQLITE_OMIT_PAGER_PRAGMAS
Defining this option omits pragmas related to the pager subsystem from the build. Currently, the default_cache_size and cache_size pragmas are omitted.

SQLITE_OMIT_PRAGMA
This option is used to omit the PRAGMA command from the library. Note that it is useful to define the macros that omit specific pragmas in addition to this, as they may also remove supporting code in other sub-systems. This macro removes the PRAGMA command only.

SQLITE_OMIT_PROGRESS_CALLBACK
This option may be defined to omit the capability to issue "progress" callbacks during long-running SQL statements. The sqlite3_progress_handler() API function is not present in the library.

SQLITE_OMIT_REINDEX
When this option is defined, the REINDEX command is not included in the library. Executing a REINDEX statement causes a parse error.

SQLITE_OMIT_SCHEMA_PRAGMAS
Defining this option omits pragmas for querying the database schema from the build. Currently, the table_info, index_info, index_list and database_list pragmas are omitted.

SQLITE_OMIT_SCHEMA_VERSION_PRAGMAS
Defining this option omits pragmas for querying and modifying the database schema version and user version from the build. Specifically, the schema_version and user_version pragmas are omitted.

SQLITE_OMIT_SUBQUERY
If defined, support for sub-selects and the IN() operator are omitted.

SQLITE_OMIT_TCL_VARIABLE
If this macro is defined, then the special "$" syntax used to automatically bind SQL variables to TCL variables is omitted.

SQLITE_OMIT_TRIGGER
Defining this option omits support for VIEW objects. Neither the CREATE TRIGGER or DROP TRIGGER commands are available in this case, attempting to execute either will result in a parse error.

WARNING: If this macro is defined, it will not be possible to open a database for which the schema contains TRIGGER objects.

SQLITE_OMIT_UTF16
This macro is used to omit support for UTF16 text encoding. When this is defined all API functions that return or accept UTF16 encoded text are unavailable. These functions can be identified by the fact that they end with '16', for example sqlite3_prepare16(), sqlite3_column_text16() and sqlite3_bind_text16().

SQLITE_OMIT_VACUUM
When this option is defined, the VACUUM command is not included in the library. Executing a VACUUM statement causes a parse error.

SQLITE_OMIT_VIEW
Defining this option omits support for VIEW objects. Neither the CREATE VIEW or DROP VIEW commands are available in this case, attempting to execute either will result in a parse error.

WARNING: If this macro is defined, it will not be possible to open a database for which the schema contains VIEW objects.

This page last modified 2007/11/14 03:21:05 UTC